Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Evaluators/AlgorithmEvaluator.cs
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Evaluators/AlgorithmEvaluator.cs	(revision 5653)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Evaluators/AlgorithmEvaluator.cs	(revision 5653)
@@ -0,0 +1,78 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Operators;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Common;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Data;
+using System.Diagnostics;
+
+namespace HeuristicLab.Problems.MetaOptimization {
+  [Item("AlgorithmEvaluator", "")]
+  [StorableClass]
+  public class AlgorithmEvaluator : SingleSuccessorOperator {
+
+    #region Parameter properties
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (LookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    public ILookupParameter<IAlgorithm> AlgorithmParameter {
+      get { return (LookupParameter<IAlgorithm>)Parameters["Algorithm"]; }
+    }
+    public ILookupParameter<IntValue> ProblemIndexParameter {
+      get { return (LookupParameter<IntValue>)Parameters["ProblemIndex"]; }
+    }
+    public ILookupParameter<IntValue> RepetitionIndexParameter {
+      get { return (LookupParameter<IntValue>)Parameters["RepetitionIndex"]; }
+    }
+    public ILookupParameter<ParameterConfigurationTree> ParameterConfigurationParameter {
+      get { return (ILookupParameter<ParameterConfigurationTree>)Parameters["ParameterConfigurationTree"]; }
+    }
+    public IValueParameter<IItemList<IRun>> RunsParameter {
+      get { return (IValueParameter<IItemList<IRun>>)Parameters["Runs"]; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected AlgorithmEvaluator(bool deserializing) : base(deserializing) { }
+    public AlgorithmEvaluator()
+      : base() {
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used to initialize the new random permutation."));
+      Parameters.Add(new LookupParameter<IAlgorithm>("Algorithm", ""));
+      Parameters.Add(new LookupParameter<IntValue>("ProblemIndex", ""));
+      Parameters.Add(new LookupParameter<IntValue>("RepetitionIndex", ""));
+      Parameters.Add(new LookupParameter<ParameterConfigurationTree>("ParameterConfigurationTree", ""));
+      Parameters.Add(new ValueParameter<IItemList<IRun>>("Runs", ""));
+    }
+    protected AlgorithmEvaluator(AlgorithmEvaluator original, Cloner cloner) : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new AlgorithmEvaluator(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      IAlgorithm algorithm = AlgorithmParameter.ActualValue;
+
+      var sw = new Stopwatch();
+      sw.Start();
+      algorithm.StartSync();
+      sw.Stop();
+      Console.WriteLine("{0},{1}: {2}", ProblemIndexParameter.ActualValue.Value, RepetitionIndexParameter.ActualValue.Value, sw.Elapsed);
+
+      RunsParameter.Value = new ItemList<IRun>(algorithm.Runs);
+
+      return base.Apply();
+    }
+
+    /// <summary>
+    /// This method should repair an invalid parameterConfiguration.
+    /// The strategy is to just randomize parameter settings. It's not guaranteed to be a vaild setting
+    /// </summary>
+    private void Repair(ParameterConfigurationTree parameterConfiguration, IRandom random) {
+      parameterConfiguration.Randomize(random);
+    }
+  }
+}
Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Evaluators/AlgorithmRunsAnalyzer.cs
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Evaluators/AlgorithmRunsAnalyzer.cs	(revision 5653)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Evaluators/AlgorithmRunsAnalyzer.cs	(revision 5653)
@@ -0,0 +1,147 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Operators;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Common;
+using HeuristicLab.Parameters;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Problems.MetaOptimization {
+  [Item("AlgorithmRunsAnalyzer", "")]
+  [StorableClass]
+  public class AlgorithmRunsAnalyzer : SingleSuccessorOperator {
+
+    #region Parameter properties
+    public ILookupParameter<DoubleValue> QualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["Quality"]; }
+    }
+    public LookupParameter<IntValue> GenerationsParameter {
+      get { return (LookupParameter<IntValue>)Parameters["Generations"]; }
+    }
+    public LookupParameter<IntValue> RepetitionsParameter {
+      get { return (LookupParameter<IntValue>)Parameters[MetaOptimizationProblem.RepetitionsParameterName]; }
+    }
+    public ILookupParameter<ParameterConfigurationTree> ParameterConfigurationParameter {
+      get { return (ILookupParameter<ParameterConfigurationTree>)Parameters["ParameterConfigurationTree"]; }
+    }
+    public ILookupParameter<IItemList<IProblem>> ProblemsParameter {
+      get { return (ILookupParameter<IItemList<IProblem>>)Parameters[MetaOptimizationProblem.ProblemsParameterName]; }
+    }
+    public LookupParameter<DoubleArray> ProblemQualityReferencesParameter {
+      get { return (LookupParameter<DoubleArray>)Parameters["ProblemQualityReferences"]; }
+    }
+    public LookupParameter<ResultCollection> ResultsParameter {
+      get { return (LookupParameter<ResultCollection>)Parameters["Results"]; }
+    }
+    public ScopeTreeLookupParameter<IAlgorithm> AlgorithmParameter {
+      get { return (ScopeTreeLookupParameter<IAlgorithm>)Parameters["Algorithm"]; }
+    }
+    public ScopeTreeLookupParameter<IntValue> ProblemIndexParameter {
+      get { return (ScopeTreeLookupParameter<IntValue>)Parameters["ProblemIndex"]; }
+    }
+    public ScopeTreeLookupParameter<IntValue> RepetitionIndexParameter {
+      get { return (ScopeTreeLookupParameter<IntValue>)Parameters["RepetitionIndex"]; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected AlgorithmRunsAnalyzer(bool deserializing) : base(deserializing) { }
+    public AlgorithmRunsAnalyzer() : base() {
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used to initialize the new random permutation."));
+      Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The evaluated quality of the ParameterVector."));
+      Parameters.Add(new LookupParameter<IntValue>("Generations", ""));
+      Parameters.Add(new LookupParameter<IntValue>(MetaOptimizationProblem.RepetitionsParameterName, "Number of evaluations on one problem."));
+      Parameters.Add(new LookupParameter<ParameterConfigurationTree>("ParameterConfigurationTree", ""));
+      Parameters.Add(new LookupParameter<IItemList<IProblem>>(MetaOptimizationProblem.ProblemsParameterName, ""));
+      Parameters.Add(new LookupParameter<DoubleArray>("ProblemQualityReferences", ""));
+      Parameters.Add(new LookupParameter<ResultCollection>("Results", ""));
+      Parameters.Add(new ScopeTreeLookupParameter<IAlgorithm>("Algorithm", "The finished algorithms containing Runs."));
+      Parameters.Add(new ScopeTreeLookupParameter<IntValue>("ProblemIndex", "The index of the problem an algorithm was executed with."));
+      Parameters.Add(new ScopeTreeLookupParameter<IntValue>("RepetitionIndex", "The index of the repetition"));
+    }
+    protected AlgorithmRunsAnalyzer(AlgorithmRunsAnalyzer original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new AlgorithmRunsAnalyzer(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      ParameterConfigurationTree parameterConfiguration = ParameterConfigurationParameter.ActualValue;
+      ItemArray<IAlgorithm> algorithms = AlgorithmParameter.ActualValue;
+      ItemArray<IntValue> problemIndices = ProblemIndexParameter.ActualValue;
+      ItemArray<IntValue> repetitionIndices = RepetitionIndexParameter.ActualValue;
+      IEnumerable<string> parameterNames = parameterConfiguration.GetOptimizedParameterNames();
+      IItemList<IProblem> problems = ProblemsParameter.ActualValue;
+      int repetitions = RepetitionsParameter.ActualValue.Value;
+      var resultNames = new List<string> { "BestQuality", "Execution Time" };
+      int currentGeneration = GenerationsParameter.ActualValue != null ? GenerationsParameter.ActualValue.Value : 0;
+      double[] referenceQualities = GetReferenceQualities(problems.Count);
+      ResultCollection results = ResultsParameter.ActualValue;
+
+      if (algorithms.All(x => x.Runs.Count == 1)) {
+        var runs = new RunCollection();
+        var qualities = new double[problems.Count][];
+        var executionTimes = new TimeSpan[problems.Count][];
+
+        for (int i = 0; i < problems.Count; i++) {
+          qualities[i] = new double[repetitions];
+          executionTimes[i] = new TimeSpan[repetitions];
+        }
+
+        for (int i = 0; i < algorithms.Length; i++) {
+          int problemIndex = problemIndices[i].Value;
+          int repetitionIndex = repetitionIndices[i].Value;
+
+          IRun run = algorithms[i].Runs.First();
+          MetaOptimizationUtil.ClearResults(run, resultNames);
+          MetaOptimizationUtil.ClearParameters(run, parameterNames);
+          run.Results.Add("Meta.FromCache", new BoolValue(false));
+          run.Results.Add("Meta.Generation", new IntValue(currentGeneration));
+          run.Results.Add("Meta.ProblemIndex", new IntValue(problemIndex));
+          run.Name = string.Format("{0} Problem {1} Run {2}", parameterConfiguration.ParameterInfoString, problemIndex, repetitionIndex);
+          qualities[problemIndex][repetitionIndex] = (((DoubleValue)run.Results["BestQuality"]).Value);
+          executionTimes[problemIndex][repetitionIndex] = (((TimeSpanValue)run.Results["Execution Time"]).Value);
+          runs.Add((IRun)run.Clone());
+        }
+
+        parameterConfiguration.AverageExecutionTimes = new ItemList<TimeSpanValue>(executionTimes.Select(t => new TimeSpanValue(TimeSpan.FromMilliseconds(t.Average(ts => ts.TotalMilliseconds)))));
+        parameterConfiguration.Repetitions = new IntValue(repetitions);
+        parameterConfiguration.BestQualities = new DoubleArray(qualities.Select(q => q.Min()).ToArray()); // todo: respect Maximization:true/false
+        parameterConfiguration.AverageQualities = new DoubleArray(qualities.Select(q => q.Average()).ToArray());
+        parameterConfiguration.WorstQualities = new DoubleArray(qualities.Select(q => q.Max()).ToArray()); // todo: respect Maximization:true/false
+        parameterConfiguration.QualityVariances = new DoubleArray(qualities.Select(q => q.Variance()).ToArray());
+        parameterConfiguration.QualityStandardDeviations = new DoubleArray(qualities.Select(q => q.StandardDeviation()).ToArray());
+        parameterConfiguration.Runs = runs;
+
+        this.QualityParameter.ActualValue = new DoubleValue(MetaOptimizationUtil.NormalizeQualities(parameterConfiguration, referenceQualities));
+      } else {
+        // something terrible happened -> most probably due to invalid parameters.
+        // penalty with worst quality from latest generation!
+
+        double penaltyValue = results.ContainsKey("CurrentWorstQuality") ? ((DoubleValue)results["CurrentWorstQuality"]).Value : referenceQualities.Max(); // todo: respect min/max
+        this.QualityParameter.ActualValue = new DoubleValue(penaltyValue);
+      }
+
+      return base.Apply();
+    }
+
+    private double[] GetReferenceQualities(int problemsCount) {
+      double[] referenceQualities;
+      if (ProblemQualityReferencesParameter.ActualValue == null) {
+        // this is generation zero. no reference qualities for normalization have been calculated yet. in this special case the ReferenceQualityAnalyzer will do the normalization
+        referenceQualities = new double[problemsCount];
+        for (int i = 0; i < referenceQualities.Length; i++) {
+          referenceQualities[i] = 1;
+        }
+      } else {
+        referenceQualities = ProblemQualityReferencesParameter.ActualValue.ToArray();
+      }
+      return referenceQualities;
+    }
+  }
+}
Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Evaluators/AlgorithmSubScopesCreator.cs
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Evaluators/AlgorithmSubScopesCreator.cs	(revision 5653)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Evaluators/AlgorithmSubScopesCreator.cs	(revision 5653)
@@ -0,0 +1,82 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Operators;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Common;
+using HeuristicLab.Parameters;
+using HeuristicLab.Optimization;
+using HeuristicLab.Data;
+using HeuristicLab.Algorithms.GeneticAlgorithm;
+
+namespace HeuristicLab.Problems.MetaOptimization {
+  [Item("ChildrenCreator", "An operator which is used to prepare crossover. The sub-scopes of the current scope the operator is applied on represent the parents. The operator creates new and empty scopes for each child, adds the scopes that represent the child's parents as sub-scopes to the child and adds the child as sub-scope to the current scope.")]
+  [StorableClass]
+  public class AlgorithmSubScopesCreator : SingleSuccessorOperator {
+    #region Parameter properties
+    public ILookupParameter<TypeValue> AlgorithmTypeParameter {
+      get { return (ILookupParameter<TypeValue>)Parameters[MetaOptimizationProblem.AlgorithmTypeParameterName]; }
+    }
+    public ILookupParameter<IItemList<IProblem>> ProblemsParameter {
+      get { return (ILookupParameter<IItemList<IProblem>>)Parameters[MetaOptimizationProblem.ProblemsParameterName]; }
+    }
+    public ILookupParameter<ParameterConfigurationTree> ParameterConfigurationParameter {
+      get { return (ILookupParameter<ParameterConfigurationTree>)Parameters["ParameterConfigurationTree"]; }
+    }
+    public LookupParameter<IntValue> RepetitionsParameter {
+      get { return (LookupParameter<IntValue>)Parameters[MetaOptimizationProblem.RepetitionsParameterName]; }
+    }
+    private ScopeParameter CurrentScopeParameter {
+      get { return (ScopeParameter)Parameters["CurrentScope"]; }
+    }
+    public IScope CurrentScope {
+      get { return CurrentScopeParameter.ActualValue; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected AlgorithmSubScopesCreator(bool deserializing) : base(deserializing) { }
+    public AlgorithmSubScopesCreator()
+      : base() {
+      Parameters.Add(new LookupParameter<TypeValue>(MetaOptimizationProblem.AlgorithmTypeParameterName, ""));
+      Parameters.Add(new LookupParameter<IItemList<IProblem>>(MetaOptimizationProblem.ProblemsParameterName, ""));
+      Parameters.Add(new LookupParameter<ParameterConfigurationTree>("ParameterConfigurationTree", ""));
+      Parameters.Add(new LookupParameter<IntValue>(MetaOptimizationProblem.RepetitionsParameterName, "Number of evaluations on one problem."));
+      Parameters.Add(new ScopeParameter("CurrentScope", "The current scope whose sub-scopes represent the parents."));
+    }
+    protected AlgorithmSubScopesCreator(AlgorithmSubScopesCreator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new AlgorithmSubScopesCreator(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      ParameterConfigurationTree parameterConfiguration = ParameterConfigurationParameter.ActualValue;
+      IItemList<IProblem> problems = ProblemsParameter.ActualValue;
+      int repetitions = RepetitionsParameter.ActualValue.Value;
+      Type algorithmType = AlgorithmTypeParameter.ActualValue.Value;
+
+      for (int i = 0; i < repetitions; i++) {
+        for (int j = 0; j < problems.Count; j++) {
+          IScope child = new Scope(string.Format("Problem {0}, Repetition {1}", j, i));
+          var algorithm = (IAlgorithm)Activator.CreateInstance(algorithmType);
+          algorithm.Problem = (IProblem)problems[j].Clone();
+          ((EngineAlgorithm)algorithm).Engine = new SequentialEngine.SequentialEngine();
+
+          //((GeneticAlgorithm)algorithm).PopulationSize.Value = 10;
+          //((GeneticAlgorithm)algorithm).MaximumGenerations.Value = 10;
+
+          parameterConfiguration.Parameterize(algorithm);
+          child.Variables.Add(new Variable("Algorithm", algorithm));
+          child.Variables.Add(new Variable("ProblemIndex", new IntValue(j)));
+          child.Variables.Add(new Variable("RepetitionIndex", new IntValue(i)));
+          CurrentScope.SubScopes.Add(child);
+        }
+      }
+      return base.Apply();
+    }
+  }
+}
Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Evaluators/PMOEvaluator.cs
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Evaluators/PMOEvaluator.cs	(revision 5653)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Evaluators/PMOEvaluator.cs	(revision 5653)
@@ -0,0 +1,91 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Operators;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Parameters;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Problems.MetaOptimization {
+  [Item("PMOEvaluator", "An operator which represents the main loop of a genetic algorithm.")]
+  [StorableClass]
+  public class PMOEvaluator : AlgorithmOperator, IParameterConfigurationEvaluator {
+
+    #region Parameter properties
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (LookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    public ILookupParameter<DoubleValue> QualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["Quality"]; }
+    }
+    public ILookupParameter<TypeValue> AlgorithmTypeParameter {
+      get { return (ILookupParameter<TypeValue>)Parameters[MetaOptimizationProblem.AlgorithmTypeParameterName]; }
+    }
+    public ILookupParameter<IItemList<IProblem>> ProblemsParameter {
+      get { return (ILookupParameter<IItemList<IProblem>>)Parameters[MetaOptimizationProblem.ProblemsParameterName]; }
+    }
+    public ILookupParameter<ParameterConfigurationTree> ParameterConfigurationParameter {
+      get { return (ILookupParameter<ParameterConfigurationTree>)Parameters["ParameterConfigurationTree"]; }
+    }
+    public LookupParameter<IntValue> RepetitionsParameter {
+      get { return (LookupParameter<IntValue>)Parameters[MetaOptimizationProblem.RepetitionsParameterName]; }
+    }
+    public LookupParameter<DoubleArray> ProblemQualityReferencesParameter {
+      get { return (LookupParameter<DoubleArray>)Parameters["ProblemQualityReferences"]; }
+    }
+    public LookupParameter<IntValue> GenerationsParameter {
+      get { return (LookupParameter<IntValue>)Parameters["Generations"]; }
+    }
+    public LookupParameter<ResultCollection> ResultsParameter {
+      get { return (LookupParameter<ResultCollection>)Parameters["Results"]; }
+    }
+    private ScopeParameter CurrentScopeParameter {
+      get { return (ScopeParameter)Parameters["CurrentScope"]; }
+    }
+    public IScope CurrentScope {
+      get { return CurrentScopeParameter.ActualValue; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected PMOEvaluator(bool deserializing) : base(deserializing) { }
+    public PMOEvaluator() {
+      Initialize();
+    }
+    protected PMOEvaluator(PMOEvaluator original, Cloner cloner) : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PMOEvaluator(this, cloner);
+    }
+
+    private void Initialize() {
+      #region Create parameters
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used to initialize the new random permutation."));
+      Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The evaluated quality of the ParameterVector."));
+      Parameters.Add(new LookupParameter<TypeValue>(MetaOptimizationProblem.AlgorithmTypeParameterName, ""));
+      Parameters.Add(new LookupParameter<IItemList<IProblem>>(MetaOptimizationProblem.ProblemsParameterName, ""));
+      Parameters.Add(new LookupParameter<ParameterConfigurationTree>("ParameterConfigurationTree", ""));
+      Parameters.Add(new LookupParameter<IntValue>(MetaOptimizationProblem.RepetitionsParameterName, "Number of evaluations on one problem."));
+      Parameters.Add(new LookupParameter<DoubleArray>("ProblemQualityReferences", ""));
+      Parameters.Add(new LookupParameter<IntValue>("Generations", ""));
+      Parameters.Add(new ScopeParameter("CurrentScope", "The current scope which represents a population of solutions on which the genetic algorithm should be applied."));
+      #endregion
+      
+      var algorithmSubScopesCreator = new AlgorithmSubScopesCreator();
+      var uniformSubScopesProcessor = new UniformSubScopesProcessor();
+      var algorithmEvaluator = new AlgorithmEvaluator();
+      var algorithmRunsAnalyzer = new AlgorithmRunsAnalyzer();
+
+      this.OperatorGraph.InitialOperator = algorithmSubScopesCreator;
+      algorithmSubScopesCreator.Successor = uniformSubScopesProcessor;
+      uniformSubScopesProcessor.Operator = algorithmEvaluator;
+      uniformSubScopesProcessor.Successor = algorithmRunsAnalyzer;
+      algorithmRunsAnalyzer.Successor = null;
+
+    }
+
+  }
+}
Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/HeuristicLab.Problems.MetaOptimization-3.3.csproj
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/HeuristicLab.Problems.MetaOptimization-3.3.csproj	(revision 5576)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/HeuristicLab.Problems.MetaOptimization-3.3.csproj	(revision 5653)
@@ -143,4 +143,10 @@
     <Compile Include="Analyzers\PMOPopulationDiversityAnalyzer.cs" />
     <Compile Include="ConstrainedTypeValue.cs" />
+    <Compile Include="Encoding\ValueConfigurations\RangeValueConfiguration.cs" />
+    <Compile Include="Encoding\ValueConfigurations\ParameterizedValueConfiguration.cs" />
+    <Compile Include="Evaluators\AlgorithmEvaluator.cs" />
+    <Compile Include="Evaluators\AlgorithmRunsAnalyzer.cs" />
+    <Compile Include="Evaluators\AlgorithmSubScopesCreator.cs" />
+    <Compile Include="Evaluators\PMOEvaluator.cs" />
     <Compile Include="MetaOptimizationUtil.cs" />
     <Compile Include="Operators\Crossovers\MultiIntValueCrossover.cs" />
@@ -167,5 +173,5 @@
     <Compile Include="Encoding\ValueConfigurations\ValueConfiguration.cs" />
     <Compile Include="Encoding\ValueConfigurations\CheckedValueConfigurationCollection.cs" />
-    <Compile Include="Evaluators\AlgorithmExecutor.cs" />
+    <Compile Include="AlgorithmExecutor.cs" />
     <Compile Include="Interfaces\IParameterConfigurationCrossover.cs" />
     <Compile Include="Interfaces\ICheckedValueConfigurationCollection.cs" />
@@ -185,5 +191,4 @@
     <Compile Include="Interfaces\IParameterConfigurationOperator.cs" />
     <Compile Include="Interfaces\IRange.cs" />
-    <Compile Include="Evaluators\ParameterConfigurationEvaluator.cs" />
     <Compile Include="Interfaces\IParameterConfigurationEvaluator.cs" />
     <Compile Include="Interfaces\IParameterConfiguration.cs" />
Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Interfaces/IOptimizable.cs
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Interfaces/IOptimizable.cs	(revision 5576)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Interfaces/IOptimizable.cs	(revision 5653)
@@ -1,8 +1,5 @@
 ﻿using System;
 using System.Collections.Generic;
-using System.Linq;
-using System.Text;
 using HeuristicLab.Core;
-using HeuristicLab.Common;
 
 namespace HeuristicLab.Problems.MetaOptimization {
Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Interfaces/IValueConfiguration.cs
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Interfaces/IValueConfiguration.cs	(revision 5576)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Interfaces/IValueConfiguration.cs	(revision 5653)
@@ -1,11 +1,7 @@
 ﻿using System;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
-using System.Collections.Generic;
 
 namespace HeuristicLab.Problems.MetaOptimization {
   public interface IValueConfiguration : IOptimizable, IItem {
-    IItemCollection<IParameterConfiguration> ParameterConfigurations { get; }
-    IRange RangeConstraint { get; }
     int Number { get; set; } // if larger than 0 it will be visible in the name. this can be used when multiple ValueConfiguration with the same name exist in a list
     string NumberedName { get; }
@@ -13,5 +9,5 @@
     event EventHandler ValueChanged;
     
-    void Parameterize(IParameterizedItem item);
+    //void Parameterize(IParameterizedItem item);
   }
 }
Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/MetaOptimizationProblem.cs
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/MetaOptimizationProblem.cs	(revision 5576)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/MetaOptimizationProblem.cs	(revision 5653)
@@ -137,5 +137,5 @@
       Maximization = new BoolValue(false);
       SolutionCreator = new RandomParameterConfigurationCreator();
-      Evaluator = new ParameterConfigurationEvaluator();
+      Evaluator = new PMOEvaluator();
 
       InitializeOperators();
@@ -186,5 +186,5 @@
     }
     private void ParameterizeEvaluator() {
-      ((ParameterConfigurationEvaluator)Evaluator).ParameterConfigurationParameter.ActualName = ((RandomParameterConfigurationCreator)SolutionCreator).ParameterConfigurationParameter.ActualName;
+      ((PMOEvaluator)Evaluator).ParameterConfigurationParameter.ActualName = ((RandomParameterConfigurationCreator)SolutionCreator).ParameterConfigurationParameter.ActualName;
     }
     private void ParameterizeAnalyzer() {
@@ -246,7 +246,8 @@
       IAlgorithm instance = (IAlgorithm)Activator.CreateInstance(AlgorithmType.Value);
       this.ProblemType.ValidTypes = ApplicationManager.Manager.GetTypes(instance.ProblemType, true).ToList();
-      this.ProblemType.Value = this.ProblemType.ValidTypes.Where(t => t != typeof(MetaOptimizationProblem)).FirstOrDefault();
+      this.ProblemType.Value = this.ProblemType.ValidTypes.SingleOrDefault(t => t == typeof(SingleObjectiveTestFunctionProblem)) ?? this.ProblemType.ValidTypes.Where(t => t != typeof(MetaOptimizationProblem)).FirstOrDefault();
       if (ProblemType.Value != null) {
         ParameterConfigurationTreeParameter.ActualValue = new ParameterConfigurationTree(CreateAlgorithm(AlgorithmType.Value, ProblemType.Value));
+        Problems.Add((IProblem)Activator.CreateInstance(this.ProblemType.Value));
       } else {
         ParameterConfigurationTreeParameter.ActualValue = null;
Index: branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Operators/Crossovers/MultiIntValueCrossover.cs
===================================================================
--- branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Operators/Crossovers/MultiIntValueCrossover.cs	(revision 5653)
+++ branches/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Operators/Crossovers/MultiIntValueCrossover.cs	(revision 5653)
@@ -0,0 +1,47 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Data;
+using HeuristicLab.Core;
+using HeuristicLab.Common;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.MetaOptimization.Operators.Crossovers {
+  [Item("MultiIntValueCrossover", "Randomly selects and applies one of its crossovers every time it is called.")]
+  [StorableClass]
+  public class MultiIntValueCrossover : StochasticMultiBranch<IIntValueCrossover>, IIntValueCrossover, IStochasticOperator {
+    public override bool CanChangeName {
+      get { return false; }
+    }
+    protected override bool CreateChildOperation {
+      get { return true; }
+    }
+
+    [StorableConstructor]
+    protected MultiIntValueCrossover(bool deserializing) : base(deserializing) { }
+    public MultiIntValueCrossover() {
+      foreach (Type type in ApplicationManager.Manager.GetTypes(typeof(IIntValueCrossover)).OrderBy(op => op.Name)) {
+        if (!typeof(MultiOperator<IIntValueCrossover>).IsAssignableFrom(type))
+          Operators.Add((IIntValueCrossover)Activator.CreateInstance(type), true);
+      }
+    }
+    protected MultiIntValueCrossover(MultiIntValueCrossover original, Cloner cloner) : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MultiIntValueCrossover(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      if (Operators.Count == 0) throw new InvalidOperationException(Name + ": Please add at least one permutation crossover to choose from.");
+      return base.Apply();
+    }
+
+    public void Apply(IRandom random, IntValue value, IntValue other, IntValueRange range) {
+
+    }
+  }
+}
